'use strict';

const express = require('express');

const modem = require('../modem');

const router = express.Router();
module.exports = router;

function handlerIndex(req, res) {
    if (!req.query || !req.query.number || !req.query.msg) {
        res.json({
            status: 'NOT-OK',
            error: 'INVALID-PARAMETER',
            message: 'Invalid parameter. Missing number or msg parameter.',
        });
        return;
    }

    res.json({
        status: 'OK',
        error: false,
        message: 'Message queued.',
    });
    modem.sendSMS(req.query.number, req.query.msg);
}

router.get('/', handlerIndex);
